unit NTConnectDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TNTConnectDlg=Class (TComponent)
  protected
    FErrorCode:DWORD;
    function GetErrorString:String;
  public
    { Public declarations }
    property ErrorString:String read GetErrorString;
    property ErrorCode:DWORD Read FErrorCode;
    procedure Execute;
  end;

procedure Register;

implementation

function TNTConnectDlg.GetErrorString:String;
begin
     Result:=SysErrorMessage(FErrorCode);
end;

procedure TNTConnectDlg.Execute;
begin
     FErrorCode:=WNetConnectionDialog(Application.Handle,RESOURCETYPE_DISK);
end;

procedure Register;
begin
  RegisterComponents('NT Tools - Additional', [TNTConnectDlg]);
end;

end.
