unit NTDisconnectDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TResourceType=(rtDisk,rtPrinter);
  TNTDisconnectDlg=class(TComponent)
  private
         FResourceType:TResourceType;
  protected
         FErrorCode:DWORD;
         function GetErrorString:String;
  public
         property ErrorString:String read GetErrorString;
         property ErrorID:DWORD Read FErrorCode;
         procedure Execute;
  published
         property ResourceType:TResourceType read FResourceType write FResourceType;
  end;

procedure Register;

implementation

function TNTDisconnectDlg.GetErrorString:String;
begin
     Result:=SysErrorMessage(FErrorCode);
end;

procedure TNTDisconnectDlg.Execute;
begin
     FErrorCode:=WNetDisconnectDialog(Application.Handle,Integer(FResourceType)+1);
end;

procedure Register;
begin
  RegisterComponents('NT Tools - Additional', [TNTDisconnectDlg]);
end;

end.
