unit NTShutdown;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TNTShutdown = class(TComponent)
  private
    { Private declarations }
    FMachineName:String;
    FMessage:String;
    FTimeOut:DWORD;
    FForceApps:Boolean;
    FReboot:Boolean;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property MachineName:String read FMachineName write FMachineName;
    property MessageText:String read FMessage write FMessage;
    property TimeOut:DWORD read FTimeOut write FTimeOut;
    property ForceApps:Boolean read FForceApps write FForceApps default False;
    property Reboot:Boolean read FReboot write FReboot default False;
    function Execute:Boolean;
  end;

procedure Register;

implementation

function TNTShutdown.Execute:Boolean;
begin
     If FMachineName='' Then
     Begin
          If InitiateSystemShutdown(nil,PChar(FMessage),FTimeOut,FForceApps,FReboot)=False Then
          Begin
               Result:=False;
               Exit;
          End;
     End Else
     Begin
          If InitiateSystemShutdown(PChar(FMachineName),PChar(FMessage),FTimeOut,FForceApps,FReboot)=False Then
          Begin
               Result:=False;
               Exit;
          End;
     End;
     Result:=True;
end;

procedure Register;
begin
  RegisterComponents('NT Tools - Additional', [TNTShutdown]);
end;

end.
