unit NTUserModalGet;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TNTUserModalGet = class(TComponent)
  private
    { Private declarations }
    FServer:String;
    FMinPasswordLen:DWORD;
    FMinPasswordAge:DWORD;
    FMaxPasswordAge:DWORD;
    FForceLogoff:DWORD;
    FPasswordHistLen:DWORD;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property Server:String read FServer write FServer;
    property MinPasswordLen:DWORD read FMinPasswordLen;
    property MinPasswordAge:DWORD read FMinPasswordAge;
    property MaxPasswordAge:DWORD read FMaxPasswordAge;
    property ForceLogoff:DWORD read FForceLogOff;
    property PasswordHistoryLen:DWORD read FPasswordHistLen;
    function Execute:LongInt;
  end;

Type USER_MODALS_INFO_0=record
	usrmod0_min_passwd_len:DWORD;
	usrmod0_max_passwd_age:DWORD;
	usrmod0_min_passwd_age:DWORD;
	usrmod0_force_logoff:DWORD;
	usrmod0_password_hist_len:DWORD;
End;

function NetUserModalsGet(Server:PWideChar;Level:DWORD;BufPtr:Pointer):LongInt; stdcall; external 'netapi32.dll';

procedure Register;

implementation

function TNTUserModalGet.Execute:LongInt;
var
   TheServer:Array[0..255] Of WideChar;
   MyInfo:USER_MODALS_INFO_0;
   MyPtr:Pointer;
begin
     StringToWideChar(FServer,@TheServer,255);
     Result:=NetUserModalsGet(@TheServer,0,@MyPtr);
     If MyPtr<>nil Then
     Begin
          MyInfo:=USER_MODALS_INFO_0(MyPtr^);
          FMinPasswordLen:=MyInfo.usrmod0_min_passwd_len;
          FMinPasswordAge:=MyInfo.usrmod0_max_passwd_age;
          FMaxPasswordAge:=MyInfo.usrmod0_min_passwd_age;
          FForceLogoff:=MyInfo.usrmod0_force_logoff;
          FPasswordHistLen:=MyInfo.usrmod0_password_hist_len;
     End Else
     Begin
          FMinPasswordLen:=0;
          FMinPasswordAge:=0;
          FMaxPasswordAge:=0;
          FForceLogoff:=0;
          FPasswordHistLen:=0;
     End;
end;

procedure Register;
begin
  RegisterComponents('NT Tools - User Management', [TNTUserModalGet]);
end;

end.
