unit NTAddGlobalUser;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TNTAddGlobalUser = class(TComponent)
  private
    { Private declarations }
    FServer:String;
    FGroup:String;
    FUserName:String;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property Server:String read FServer write FServer;
    property UserName:String read FUserName write FUserName;
    property Group:String read FGroup write FGroup;
    function Execute:LongInt;
  end;

function NetGroupAddUser(ServerName:PWideChar;GroupName:PWideChar;UserName:PWideChar):LongInt; stdcall; external 'netapi32.dll';

procedure Register;

implementation

function TNTAddGlobalUser.Execute:LongInt;
var
   tServer:Array[0..255] Of WideChar;
   tUser:Array[0..255] Of WideChar;
   tGroup:Array[0..255] Of WideChar;
begin
     StringToWideChar(FServer,@tServer,255);
     StringToWideChar(FUserName,@tUser,255);
     StringToWideChar(FGroup,@tGroup,255);
     Result:=NetGroupAddUser(@tServer,@tGroup,@tUser);
end;

procedure Register;
begin
  RegisterComponents('NT Tools - Global', [TNTAddGlobalUser]);
end;

end.
