unit NTLocalGetInfo;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TNTLocalGetInfo = class(TComponent)
  private
    { Private declarations }
    FServer:String;
    FGroup:String;
    FName:String;
    FComment:String;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property Server:String read FServer write FServer;
    property Group:String read FGroup write FGroup;
    property Name:String read FName;
    property Comment:String read FComment;
    function Execute:LongInt;
  end;

Type LOCALGROUP_INFO_1=record
	lgrpi1_name:LPWSTR;
	lgrpi1_comment:LPWSTR;
End;

function NetLocalGroupGetInfo(Server:PWideChar;GroupName:PWideChar;Level:DWORD;BufPtr:Pointer):LongInt; stdcall; external 'netapi32.dll';

procedure Register;

implementation

function TNTLocalGetInfo.Execute:LongInt;
var
   tServer:Array[0..255] Of WideChar;
   tGroup:Array[0..255] Of WideChar;
   MyPtr:Pointer;
   MyInfo:LOCALGROUP_INFO_1;
begin
     StringToWideChar(FServer,@tServer,255);
     StringToWideChar(FGroup,@tGroup,255);
     Result:=NetLocalGroupGetInfo(@tServer,@tGroup,1,@MyPtr);
     If MyPtr<>nil Then
     Begin
          MyInfo:=LOCALGROUP_INFO_1(MyPtr^);
          FName:=WideCharToString(MyInfo.lgrpi1_name);
          FComment:=WideCharToString(MyInfo.lgrpi1_comment);
     End;
end;

procedure Register;
begin
  RegisterComponents('NT Tools - Local', [TNTLocalGetInfo]);
end;

end.
