unit NTLocalSetInfo;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TNTLocalSetInfo = class(TComponent)
  private
    { Private declarations }
    FServer:String;
    FGroup:String;
    FName:String;
    FComment:String;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property Server:String read FServer write FServer;
    property Group:String read FGroup write FGroup;
    property Name:String read FName write FName;
    property Comment:String read FComment write FComment;
    function Execute:LongInt;
  end;

Type LOCALGROUP_INFO_1=record
	lgrpi1_name:LPWSTR;
	lgrpi1_comment:LPWSTR;
End;

function NetLocalGroupSetInfo(Server:PWideChar;GroupName:PWideChar;Level:DWORD;Buffer:PChar;ParmError:LPDWORD):LongInt; stdcall; external 'netapi32.dll';

procedure Register;

implementation

function TNTLocalSetInfo.Execute:LongInt;
var
   tServer:Array[0..255] Of WideChar;
   tGroup:Array[0..255] Of WideChar;
   tName:Array[0..255] Of WideChar;
   tComment:Array[0..255] Of WideChar;
   MyInfo:LOCALGROUP_INFO_1;
   Where:LPDWORD;
begin
     Where:=nil;
     StringToWideChar(FServer,@tServer,255);
     StringToWideChar(FGroup,@tGroup,255);
     StringToWideChar(FName,@tName,255);
     StringToWideChar(FComment,@tComment,255);
     MyInfo.lgrpi1_name:=@tName;
     MyInfo.lgrpi1_comment:=@tComment;
     Result:=NetLocalGroupSetInfo(@tServer,@tGroup,1,@MyInfo,Where);
end;

procedure Register;
begin
  RegisterComponents('NT Tools - Local', [TNTLocalSetInfo]);
end;

end.
