unit NTUserModalSet;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TNTUserModalSet = class(TComponent)
  private
    { Private declarations }
    FServer:String;
    FMinPasswordLen:DWORD;
    FMinPasswordAge:DWORD;
    FMaxPasswordAge:DWORD;
    FForceLogoff:DWORD;
    FPasswordHistLen:DWORD;
  protected
    { Protected declarations }
  public
    { Public declarations }
  published
    { Published declarations }
    property Server:String read FServer write FServer;
    property MinPasswordLen:DWORD read FMinPasswordLen write FMinPasswordLen default 0;
    property MinPasswordAge:DWORD read FMinPasswordAge write FMinPasswordAge default 0;
    property MaxPasswordAge:DWORD read FMaxPasswordAge write FMaxPasswordAge default 0;
    property ForceLogoff:DWORD read FForceLogOff write FForceLogOff default 0;
    property PasswordHistoryLen:DWORD read FPasswordHistLen write FPasswordHistLen default 0;
    function Execute:LongInt;
  end;

Type USER_MODALS_INFO_0=record
	usrmod0_min_passwd_len:DWORD;
	usrmod0_max_passwd_age:DWORD;
	usrmod0_min_passwd_age:DWORD;
	usrmod0_force_logoff:DWORD;
	usrmod0_password_hist_len:DWORD;
End;

function NetUserModalsSet(Server:PWideChar;Level:DWORD;Buf:PChar;ParmError:LPDWORD):LongInt; stdcall; external 'netapi32.dll';

procedure Register;

implementation

function TNTUserModalSet.Execute:LongInt;
var
   TheServer:Array[0..255] Of WideChar;
   MyInfo:USER_MODALS_INFO_0;
begin
     StringToWideChar(FServer,@TheServer,255);
     MyInfo.usrmod0_min_passwd_len:=FMinPasswordLen;
     MyInfo.usrmod0_max_passwd_age:=FMinPasswordAge;
     MyInfo.usrmod0_min_passwd_age:=FMaxPasswordAge;
     MyInfo.usrmod0_force_logoff:=FForceLogoff;
     MyInfo.usrmod0_password_hist_len:=FPasswordHistLen;
     Result:=NetUserModalsSet(@TheServer,0,@MyInfo,nil);
end;

procedure Register;
begin
  RegisterComponents('NT Tools - User Management', [TNTUserModalSet]);
end;

end.
